package de.flothow.prog3.philosophers;

public class Philosopher extends Thread {
	protected String name;
	private Chopstick leftStick;
	private Chopstick rightStick;
	private volatile boolean keepGoing = true;

	public Philosopher(String name, Chopstick leftStick, Chopstick rightStick) {
		this.name = name;
		this.leftStick = leftStick;
		this.rightStick = rightStick;
	}

	@Override
	public void run() {
		try {
			while (keepGoing) {
				Thread.sleep(100);
				System.out.println(name + " wartet auf Stab "
						+ leftStick.getI());
				synchronized (leftStick) {
					System.out.println(name + " hat Stab " + leftStick.getI());

					Thread.sleep(100);
					System.out.println(name + " wartet auf Stab "
							+ rightStick.getI());
					synchronized (rightStick) {
						System.out.println(name + " hat Stab "
								+ rightStick.getI());
						Thread.sleep(100);
						eat();
						Thread.sleep(100);
						System.out.println(name + " legt Stab "
								+ rightStick.getI() + " ab");
					}

					Thread.sleep(100);
					System.out.println(name + " legt Stab " + leftStick.getI()
							+ " ab");
				}

				Thread.sleep(100);
				think();
			}

			System.out.println(name + " verlässt den Tisch");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/*
	 * @Override public void run() { try { while (keepGoing) {
	 * Thread.sleep(100); System.out.println(name + " wartet auf Stab " +
	 * leftStick.getI()); leftStick.lock(); System.out.println(name +
	 * " hat Stab " + leftStick.getI());
	 * 
	 * try { Thread.sleep(100); System.out.println(name + " wartet auf Stab " +
	 * rightStick.getI()); rightStick.lock(); System.out.println(name +
	 * " hat Stab " + rightStick.getI()); try { Thread.sleep(100); eat(); }
	 * finally { Thread.sleep(100); System.out.println(name + " legt Stab " +
	 * rightStick.getI() + " ab"); rightStick.unlock(); } } finally {
	 * Thread.sleep(100); System.out.println(name + " legt Stab " +
	 * leftStick.getI() + " ab"); leftStick.unlock(); }
	 * 
	 * Thread.sleep(100); think(); }
	 * 
	 * System.out.println(name + " verlässt den Tisch"); } catch (Exception e) {
	 * e.printStackTrace(); } }
	 */

	protected void think() throws InterruptedException {
		System.out.println(name + " denkt");
		Thread.sleep((long) (5000));
	}

	protected void eat() throws InterruptedException {
		System.out.println(name + " isst");
		Thread.sleep((long) (5000));
	}

	protected void leave() {
		keepGoing = false;
	}
}
